#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\Blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "data.h"
#include "resource\BitMapFont.h"
#include "resource\tile.map.h"
#include <stdlib.h>
#include <string.h>

//const int __gba_multiboot;  //GBANp

#define TRUE  (1)
#define FALSE (0)

#define MAP_CX        256
#define MAP_CY        256
#define BLOCK_CX      32
#define BLOCK_CY      32
#define MAP_BLOCK_CX  (MAP_CX / BLOCK_CX)
#define MAP_BLOCK_CY  (MAP_CY / BLOCK_CY)
#define MAP_BLOCK_CNT (MAP_BLOCK_CX * MAP_BLOCK_CY)

#define CHR_SYSTEM_CNT 1
#define CHR_FRIEND_CNT 2
#define CHR_ENEMY_CNT  1
#define CHR_ALL_CNT    (CHR_FRIEND_CNT + CHR_ENEMY_CNT + CHR_SYSTEM_CNT)

#define ATTRIBUTE_CORP_FRIEND 1		//ST_CHR\̂CorpϐɎg
#define ATTRIBUTE_CORP_ENEMY  2
#define ATTRIBUTE_CORP_SYSTEM 3

#define GRASS  1	//}bv`bv̈ړ
#define TOWN   1
#define FOREST 2
#define DESERT 2
#define CASTLE 3
#define MOUNTG 3
#define MOUNTD 3
#define RIVER  99

#define CHR_SYSTEM_CURSER 3		//J[\CHRԍ
//---------------------------------------------------------------------------
typedef struct {
	u8  x;
	u8  y;
	u8  cx;
	u8  cy;
}ST_CAMERA;

ST_CAMERA  CAMERA;		//GBAɕ\MAP͈

typedef struct {
	u8  VisitFlag;
	u8  Name[12];
	u8  x;				//}bvW
	u8  y;
	u8  Hp;
	u8  Corp;			//1:FRIEND 2:ENEMY 3:SYSTEM
	u8  Move;			//ړ
	u16 SprNo;			//GBÃXvCgNo
	u16 SprAnime[2];	//Aj[Vp^[
}ST_CHR;

ST_CHR  CHR[CHR_ALL_CNT];

//n`}bv̈ړ
u8 LandMap[MAP_BLOCK_CNT] = {
  GRASS,   GRASS, GRASS,  RIVER,  RIVER,  RIVER,  GRASS, FOREST,
  GRASS,  MOUNTG, GRASS,  RIVER,  RIVER, FOREST,   TOWN,  GRASS,
  GRASS,    TOWN, GRASS,  RIVER,  GRASS,  GRASS,  GRASS,  GRASS,
  GRASS,   GRASS, GRASS,  RIVER,  GRASS,  GRASS,  GRASS,  GRASS,
  GRASS,   GRASS, GRASS, DESERT,  GRASS,  GRASS, FOREST, DESERT,
  MOUNTG,  GRASS, RIVER,  RIVER,  GRASS,  GRASS,  GRASS, DESERT,
  MOUNTG, MOUNTG, RIVER,  RIVER, MOUNTD, DESERT, DESERT, DESERT,
  GRASS,   GRASS, RIVER,  RIVER, MOUNTD, DESERT, DESERT, CASTLE,
};

//LN^[ړ͈
u8  RangeMap[MAP_BLOCK_CX][MAP_BLOCK_CY];
//ڕWUNIT܂ł̈ړʂ̎ZoɎg
u8 TargetMap[MAP_BLOCK_CX][MAP_BLOCK_CY];

u8 BG2Chr;
u8 BG2Map;
u8 BG3Chr;
u8 BG3Map;
u8 AnimePattern;
//---------------------------------------------------------------------------
void Init();
void InitBG();
void InitChr();
void InitSprit();
void InitTimer();
void InitArrayMap(u8 [][], u8, u8);

void DispChr(u8);
void DispAllChr();
void DispChrRangeOn();
void DispChrRangeOff();

void TurnFriend(u8);
void TurnEnemy(u8);

void InputMoveChr(u8);
void MosterMoveChr(u8);
void MoveChr(u8);

void CalcChrRange(u8);
void CalcChrRangeRe(s8, s8, s16);
void CalcChrTarget(u8);
void CalcChrTargetRe(s8, s8, s16);

void ChangeCameraPoint(s8, s8);

void WaitPushA();
void Wait500ms();

void IRQ_USER_Handler();
void IRQ_USER_Setup();

void DebugRangeMap();
void DebugTargetMap();
//---------------------------------------------------------------------------
int main(void)
{
	Init();
	InitBG();
	InitChr();
	InitSprit();
	InitTimer();

	// BG2 LN^ړ͈͂̕\
	// BG3 n`̕\
	REG_COLEV   = BLEND_BALANCE(0);
	REG_BLDMOD  = BLEND_TOP_BG2 | BLEND_LOW_BG3 | BLEND_MODE_ALPHA;
	REG_DISPCNT = MODE_0 | BG2_ENABLE | BG3_ENABLE | OBJ_ENABLE | OBJ_MAP_2D;

	DispAllChr();

	u8 i;
	for(;;)
	{
		for(i=0; i<CHR_ALL_CNT; i++)
		{
			if(CHR[i].Corp == ATTRIBUTE_CORP_FRIEND)
			{
				TurnFriend(i);
				Wait500ms();
			}
			if(CHR[i].Corp == ATTRIBUTE_CORP_ENEMY)
			{
				TurnEnemy(i);
				Wait500ms();
			}

		}
	}

	return 0;
}
//---------------------------------------------------------------------------
void TurnFriend(u8 ChrNum)
{
	InitArrayMap(RangeMap, MAP_BLOCK_CX, MAP_BLOCK_CY);

	CalcChrRange(ChrNum);
	DispChrRangeOn();

	InputMoveChr(ChrNum);
	DispChrRangeOff();
}
//---------------------------------------------------------------------------
void TurnEnemy(u8 ChrNum)
{
	InitArrayMap(RangeMap , MAP_BLOCK_CX, MAP_BLOCK_CY);
	InitArrayMap(TargetMap, MAP_BLOCK_CX, MAP_BLOCK_CY);

	CalcChrRange(ChrNum);
	DispChrRangeOn();

	//X^̃^[QbgUNIT0ԖڂɌŒ肵Ă܂
	CalcChrTarget(0);
	MosterMoveChr(ChrNum);
	DispChrRangeOff();
}
//---------------------------------------------------------------------------
void Init()
{
	Mode3SetBitMapFont((u8*)BitMapFont, 8,8,0);
	AnimePattern = 0;

	CAMERA.x  = 0;
	CAMERA.y  = 0;
	CAMERA.cx = 7;
	CAMERA.cy = 5;
}
//---------------------------------------------------------------------------
void InitBG()
{
	BG3Chr = 1;
	BG3Map = 0;
	BG2Chr = 1;		//BG3Ɠchrg
	BG2Map = 2;

	REG_BG2CNT = (BG_SIZEA_256_256    | BG_COLOR_256       |
                  BG_CHARBASE(BG2Chr) | BG_MAPBASE(BG2Map) | 0);
	REG_BG3CNT = (BG_SIZEA_256_256    | BG_COLOR_256       |
                  BG_CHARBASE(BG3Chr) | BG_MAPBASE(BG3Map) | 0);

	BGSetPal256((u16*)EtfsGetDataOffset(_TILE_IMG_PAL_OFFSET));
	BGSetChrData(BG3Chr, (u16*)EtfsGetDataOffset(_TILE_IMG_BIN_OFFSET), _TILE_IMG_BIN_SIZE);
	BGSetMapData(BG3Map, (u16*)tileData, tileSize*4);
	BGDrawCls   (BG2Map, 0x0010);
}
//---------------------------------------------------------------------------
void InitSprit()
{
	SpriteInitialize();
	SpriteSetPal256((u16*)EtfsGetDataOffset(_TILE_IMG_PAL_OFFSET));
	SpriteSetData  ((u16*)EtfsGetDataOffset(_SPRCHR_IMG_BIN_OFFSET), _SPRCHR_IMG_BIN_SIZE);

	u16 i;
	for(i=0; i<CHR_ALL_CNT; i++)
	{
		SpriteSetSize(i, SP_SIZE_32, SP_SQUARE, SP_COLOR_256);
	}
}
//---------------------------------------------------------------------------
void InitTimer()
{
	IRQ_USER_Setup();

	REG_TM0D   = 0x8000;
	REG_TM0CNT = TM_ENABLE | TM_FREQ_PER_256 | TM_USEIRQ;
}
//---------------------------------------------------------------------------
void InitChr()
{
	strcpy(CHR[0].Name, "@g");
	CHR[0].VisitFlag   = TRUE;
	CHR[0].Corp        = ATTRIBUTE_CORP_FRIEND;
	CHR[0].Hp          = 3;
	CHR[0].x           = 0;
	CHR[0].y           = 1;
	CHR[0].Move        = 4;
	CHR[0].SprNo       = 0;
	CHR[0].SprAnime[0] = 0x00;
	CHR[0].SprAnime[1] = 0x81;

	strcpy(CHR[1].Name, "m");
	CHR[1].VisitFlag   = TRUE;
	CHR[1].Corp        = ATTRIBUTE_CORP_FRIEND;
	CHR[1].Hp          = 1;
	CHR[1].x           = 1;
	CHR[1].y           = 0;
	CHR[1].Move        = 4;
	CHR[1].SprNo       = 1;
	CHR[1].SprAnime[0] = 0x08;
	CHR[1].SprAnime[1] = 0x89;

	strcpy(CHR[2].Name, "G`");
	CHR[2].VisitFlag   = TRUE;
	CHR[2].Corp        = ATTRIBUTE_CORP_ENEMY;
	CHR[2].Hp          = 1;
	CHR[2].x           = 6;
	CHR[2].y           = 3;
	CHR[2].Move        = 3;
	CHR[2].SprNo       = 2;
	CHR[2].SprAnime[0] = 0x101;
	CHR[2].SprAnime[1] = 0x181;

	strcpy(CHR[3].Name, "Cursor");
	CHR[3].VisitFlag   = FALSE;
	CHR[3].Corp        = ATTRIBUTE_CORP_SYSTEM;
	CHR[3].Hp          = 0;
	CHR[3].x           = 0;
	CHR[3].y           = 0;
	CHR[3].Move        = 0;
	CHR[3].SprNo       = 3;
	CHR[3].SprAnime[0] = 0x109;
	CHR[3].SprAnime[1] = 0x189;
}
//---------------------------------------------------------------------------
void DispAllChr()
{
	u8 i;
	for(i=0; i<CHR_ALL_CNT; i++)
	{
		DispChr(i);
	}
}
//---------------------------------------------------------------------------
void DispChr(u8 i)
{
	if(CHR[i].VisitFlag == TRUE)
	{
		SpriteSetChr(CHR[i].SprNo, CHR[i].SprAnime[AnimePattern]);
	}
	else
	{
		SpriteSetChr(CHR[i].SprNo, 0x110); //
	}
	MoveChr(i);
}
//---------------------------------------------------------------------------
void DispChrRangeOn()
{
	//LN^̈ړׂ͈͂čFɂ
	BGDrawCls(BG2Map, 0x0010);

	//ړ\͈͂𓧖Fɂ
	u8 x, y;
	for(y=0; y<MAP_BLOCK_CY; y++)
	{
		for(x=0; x<MAP_BLOCK_CX; x++)
		{
			if(RangeMap[x][y] != 0)
			{
				//Pȏ̈ړʂꍇ
				BGDrawBox(BG2Map, x,y, 4,4, 0x0090);
			}
		}
	}

	//\
	WaitForVsync();
	REG_COLEV = BLEND_BALANCE(8);
}
//---------------------------------------------------------------------------
void DispChrRangeOff()
{
	WaitForVsync();
	REG_COLEV = BLEND_BALANCE(0);
}
//---------------------------------------------------------------------------
void MoveChr(u8 chrNum)
{
	u8 x = CHR[chrNum].x * BLOCK_CX;
	u8 y = CHR[chrNum].y * BLOCK_CY;

	//J_
	x -= CAMERA.x * BLOCK_CX/2;
	y -= CAMERA.y * BLOCK_CY;
	
	SpriteMove(CHR[chrNum].SprNo, x, y);
}
//---------------------------------------------------------------------------
void CalcChrRange(u8 ChrNum)
{
	s8  ChrX = CHR[ChrNum].x;
	s8  ChrY = CHR[ChrNum].y;
	s16 Move = CHR[ChrNum].Move;		//LN^ړ

	//̏ꏊvẐŐɉƂ
	Move += LandMap[ChrX + ChrY*MAP_BLOCK_CX];

	CalcChrRangeRe(ChrX, ChrY, Move);
	//DebugRangeMap();
}
//---------------------------------------------------------------------------
void CalcChrRangeRe(s8 x, s8 y, s16 Move)
{
	if(x<0 || x>MAP_BLOCK_CX-1) return;
	if(y<0 || y>MAP_BLOCK_CY-1) return;

	Move -= LandMap[x + y*MAP_BLOCK_CX];

	if(Move<=0)
	{
		return;
	}
	
	if(RangeMap[x][y] < Move)
	{
		RangeMap[x][y] = Move;
	}

	CalcChrRangeRe(x+1, y  , Move);
	CalcChrRangeRe(x-1, y  , Move);
	CalcChrRangeRe(x  , y+1, Move);
	CalcChrRangeRe(x  , y-1, Move);
}
//---------------------------------------------------------------------------
void InputMoveChr(u8 chrNum)
{
	u8 srNum = CHR_SYSTEM_CURSER;
	
	CHR[srNum].x         = CHR[chrNum].x;
	CHR[srNum].y         = CHR[chrNum].y;
	CHR[srNum].VisitFlag = TRUE;
	DispChr(srNum);

	u8 x,y;
	u8 Key;
	KeyInitialize();
	for(;;)
	{
		WaitForVsync();
		ChangeCameraPoint(CHR[srNum].x, CHR[srNum].y);
		DispAllChr();
		
		Key = KeyInput();
		
		//G[`FbNȂ܂m(__)m
		if(Key & KEY_A)
		{
			x = CHR[srNum].x;
			y = CHR[srNum].y;
			
			if(RangeMap[x][y] != 0)
			{
				break;
			}
		}
		if(Key & KEY_UP   ) CHR[srNum].y--;
		if(Key & KEY_DOWN ) CHR[srNum].y++;
		if(Key & KEY_LEFT ) CHR[srNum].x--;
		if(Key & KEY_RIGHT) CHR[srNum].x++;

	} //for(;;)

	WaitKey(KEY_A);

	CHR[srNum].VisitFlag = FALSE;
	DispChr(srNum);

	CHR[chrNum].x = CHR[srNum].x;
	CHR[chrNum].y = CHR[srNum].y;
	DispChr(chrNum);
}
//---------------------------------------------------------------------------
void ChangeCameraPoint(s8 mapX, s8 mapY)
{
	if(mapX<0 || mapX>MAP_BLOCK_CX-1) return;
	if(mapY<0 || mapY>MAP_BLOCK_CY-1) return;

	if(mapX < CAMERA.x)             CAMERA.x--;
	if(mapX > CAMERA.x+CAMERA.cx-1) CAMERA.x++;
	if(mapY < CAMERA.y)             CAMERA.y--;
	if(mapY > CAMERA.y+CAMERA.cy-1) CAMERA.y++;

	REG_BG2HOFS = CAMERA.x * (BLOCK_CX/2);		//x
	REG_BG3HOFS = CAMERA.x * (BLOCK_CX/2);

	REG_BG2VOFS = CAMERA.y * BLOCK_CY;			//y
	REG_BG3VOFS = CAMERA.y * BLOCK_CY;
}
//---------------------------------------------------------------------------
//ChrNumԖڂUNITɈԋ߂}bvW𓱂܂
void MosterMoveChr(u8 ChrNum)
{
	u8 x, y;
	u8 moveX=0, moveY=0, move=99;
	
	for(y=0; y<MAP_BLOCK_CY; y++)
	{
		for(x=0; x<MAP_BLOCK_CX; x++)
		{
			if(TargetMap[x][y] < move
				&& TargetMap[x][y] != 0
				&&  RangeMap[x][y] != 0)
			{
				moveX = x;
				moveY = y;
				move  = TargetMap[x][y];
			}
		}
	}

	CHR[ChrNum].x = moveX;
	CHR[ChrNum].y = moveY;
	MoveChr(ChrNum);
}
//========================================================================
void IRQ_USER_Handler()
{
	REG_IME = IRQ_MASTER_OFF;
	u16 IF_flag = REG_IF;

	if(IF_flag & IRQ_BIT_TIMER0)
	{
		AnimePattern = (AnimePattern + 1) % 2;
		DispAllChr();

		REG_TM0D = 0x8000;
	}

	REG_IF  = IF_flag;
	REG_IME = IRQ_MASTER_ON;
}
//========================================================================
void IRQ_USER_Setup()
{
	REG_IME = IRQ_MASTER_OFF;

	REG_INTERUPT  = (u32)IRQ_USER_Handler;
	REG_IE       |= IRQ_BIT_TIMER0;

	REG_IME = IRQ_MASTER_ON;
}
//---------------------------------------------------------------------------
void Wait500ms()
{
	REG_TM1D   = 0;
	REG_TM1CNT = TM_FREQ_PER_256 | TM_ENABLE;

	while(REG_TM1D < 0x8000)
	{
		Mode3DrawBitMapStr(1,1,""); //gcc̍œK̂߂while[vȂ݂
									//Ȃ̂ŁAeLg[ȏƂ
	}

	REG_TM1CNT = TM_DISABLE;
	REG_TM1D   = 0;
}
//---------------------------------------------------------------------------
void InitArrayMap(u8 Map[][MAP_BLOCK_CY], u8 stopX, u8 stopY)
{
	u8 x, y;

	for(y=0; y<stopY; y++)
	{
		for(x=0; x<stopX; x++)
		{
			Map[x][y] = 0;
		}
	}
}
//---------------------------------------------------------------------------
void CalcChrTarget(u8 ChrNum)
{
	s8 ChrX = CHR[ChrNum].x;
	s8 ChrY = CHR[ChrNum].y;

	CalcChrTargetRe(ChrX, ChrY, 0);
	//DebugTargetMap();
}
//---------------------------------------------------------------------------
void CalcChrTargetRe(s8 x, s8 y, s16 Move)
{
	if(x<0 || x>MAP_BLOCK_CX-1) return;
	if(y<0 || y>MAP_BLOCK_CY-1) return;

	Move += LandMap[x + y*MAP_BLOCK_CX];

	if(Move>=99)
	{
		return;
	}

	if(TargetMap[x][y] == 0 || TargetMap[x][y] > Move)
	{
		TargetMap[x][y] = Move;
	}
	else
	{
		//̈ړʂ傫̂ŃoCoCႢ܂
		return;
	}

	CalcChrTargetRe(x+1, y  , Move);
	CalcChrTargetRe(x-1, y  , Move);
	CalcChrTargetRe(x  , y+1, Move);
	CalcChrTargetRe(x  , y-1, Move);
}









//---------------------------------------------------------------------------
void DebugRangeMap()
{
	u8 x, y;

	for(y=0; y<MAP_BLOCK_CY; y++)
	{
		for(x=0; x<MAP_BLOCK_CX; x++)
		{
			dprintf("%3d,",RangeMap[x][y]);
		}
		dprintf("\n");
	}
	dprintf("\n");
}
//---------------------------------------------------------------------------
void DebugTargetMap()
{
	u8 x, y;

	for(y=0; y<MAP_BLOCK_CY; y++)
	{
		for(x=0; x<MAP_BLOCK_CX; x++)
		{
			dprintf("%3d,",TargetMap[x][y]);
		}
		dprintf("\n");
	}
	dprintf("\n");
}
